
-- Vama perälevyn kääntö skripti
-- Truck-King 22/12/2014 www.ls-fin.com

Vama = {};

function Vama.prerequisitesPresent(specializations)
    return true;
end;

function Vama:load(xmlFile)
self.stateIndex = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotatablePart#index"));

self.states = {};
self.states[1] = math.rad (-46);
self.states[2] = math.rad (-28);
self.states[3] = math.rad (-11);
self.states[4] = math.rad (0);
self.states[5] = math.rad (11);
self.states[6] = math.rad (28);
self.states[7] = math.rad (46);
self.stateNum = 4;
end;

function Vama:delete()
end;
function Vama:mouseEvent(posX, posY, isDown, isUp, button)
end;
function Vama:keyEvent(unicode, sym, modifier, isDown)

end;

function Vama:update(dt)	
if self:getIsActive() then
	if self.stateIndex ~= nil then 
		if InputBinding.hasEvent(InputBinding.ROT_PART_MIN) and self.stateNum > 1 then
		self.stateNum = self.stateNum-1;
		end;
		if InputBinding.hasEvent(InputBinding.ROT_PART_MAX) and self.stateNum < 7 then
		self.stateNum = self.stateNum+1;
		end;
		
		local indexRotX, indexRotY, indexRotZ = getRotation(self.stateIndex);		
		if indexRotY - self.states[self.stateNum] > 0.001 then
			setRotation(self.stateIndex, indexRotX, indexRotY- math.rad(0.5), indexRotZ);
		end;
		if self.states[self.stateNum] - indexRotY > 0.001 then
			setRotation(self.stateIndex, indexRotX, indexRotY+ math.rad(0.5), indexRotZ);
		end;
	end;		
end;
end;

function Vama:updateTick(dt)
end;

function Vama:draw()
--renderText(0.41,0.41, 0.02,self.stateNum .. "  " .. self.states[self.stateNum] );
g_currentMission:addHelpButtonText("Takalana kääntö vasemmalle", InputBinding.ROT_PART_MIN);
g_currentMission:addHelpButtonText("Takalana kääntö oikealle", InputBinding.ROT_PART_MAX);
end;


function Vama:readStream(streamId, connection)
	local netStates = streamReadInt8(streamId);
	if netStates ~= self.stateNum then
		self.stateNum = netStates;
	end;
end;

function Vama:writeStream(streamId, connection)
	streamWriteInt8(streamId, self.stateNum);
end;